# $Hg$

import kwexpander

def updatekw(ui, repo, hooktype, **args):
    '''Collects candidates for keyword expansion on update
    and passes them to kwexpander.'''

    if hooktype != 'update':
        # bail out with error
        return True

    n1, n2 = args['parent1'], args['parent2']
    r1 = repo.changelog.lookup(n1)
    if n2:
        r2 = repo.changelog.lookup(n2)
        # next line for debugging only (check merges)
        ui.warn('parent2: %s\n' % n2)
    else:
        r2 = None

    (modified, added, removed, deleted,
            unknown, ignored, clean) = repo.status(node1=r1, node2=r2)
    candidates = modified + added + clean

    if  candidates:
        return kwexpander.expandkw(ui, repo, r1, n1, candidates, update=True)
